<?php
namespace Models;

// модель для чеков
class Receipts extends \DB\SQL\Mapper {
	public $db, $f3, $fr, $egais, $printer;

	public function __construct($db, $f3, $printer='kkm') {
		parent::__construct($db, 'receipts'); // подключаемся к таблице чеков
		$this->db=$db;
		$this->f3=$f3;
		$this->fr=new \Models\Fr($db, $f3, $printer);
		if($printer!='kkm' && $this->fr->sets['active']!=1) {
			$this->fr=new \Models\Fr($db, $f3, 'kkm');
		}
		$this->printer=$printer;
		$this->egais=new \Models\Egais($db, $f3);
	}

	// Информация об открываемой странице
	function page_data($page='sales') {
		$pages=array(
			'sales'=>array(
				'title'=>'Продажа',
				'inc'=>'receipts_sales.htm'
			),
			'return'=>array(
				'title'=>'Возврат',
				'inc'=>'receipts_return.htm'
			),
			'search'=>array(
				'title'=>'Поиск чеков',
				'inc'=>'receipts_search.htm'
			),
			'paymentmethods'=>array(
				'title'=>'Оплата чека',
				'inc'=>'receipts_paymentmethods.htm'
			),
			'show'=>array(
				'title'=>'Просмотр чека',
				'inc'=>'receipts_show.htm'
			),
			'change_price'=>array(
				'title'=>'Редактирование цены продажи',
				'inc'=>'receipts_change_price.htm'
			),
			'cashin'=>array(
				'title'=>'Внесение денег в кассу',
				'inc'=>'receipts_cashin.htm'
			),
			'cashout'=>array(
				'title'=>'Изъятие денег из кассы',
				'inc'=>'receipts_cashout.htm'
			),
			'reports'=>array(
				'title'=>'Смены и отчеты',
				'inc'=>'receipts_reports.htm'
			),
			'new'=>array(
				'title'=>'Открытие нового чека',
				'inc'=>'receipts_new.htm'
			),
			'switch'=>array(
				'title'=>'Переключение на другой чек',
				'inc'=>'receipts_switch.htm'
			),
			'all_open'=>array(
				'title'=>'Открытые чеки',
				'inc'=>'receipts_all_open.htm'
			),
			'move'=>array(
				'title'=>'Перемещение чека на другой стол',
				'inc'=>'receipts_move.htm'
			),
			'online_order'=>array(
				'title'=>'Поиск документов',
				'inc'=>'receipts_online_order.htm'
			),
			'online_order_result'=>array(
				'title'=>'Документы',
				'inc'=>'receipts_online_order_result.htm'
			),
			'print'=>array(
				'title'=>'Печать чека',
				'inc'=>'receipts_print.htm'
			),
			'walk'=>array(
				'title'=>'Отметить проход сотрудника',
				'inc'=>'receipts_walk.htm'
			),
			'walk_add_card'=>array(
				'title'=>'Отметить проход сотрудника',
				'inc'=>'receipts_walk_add_card.htm'
			),
			'add_marking'=>array(
				'title'=>'Укажите код маркировки товара',
				'inc'=>'receipts_add_marking.htm'
			),
			'marking_error'=>array(
				'title'=>'Ошибка проверки кода маркировки товара',
				'inc'=>'receipts_marking_error.htm'
			),
			'mrc_error'=>array(
				'title'=>'Ошибка проверки кода маркировки товара',
				'inc'=>'receipts_mrc_error.htm'
			),
			'egais_error'=>array(
				'title'=>'Ошибка проверки алкогольной продукции',
				'inc'=>'receipts_egais_error.htm'
			),
			'chpok'=>array(
				'title'=>'Вскрытие тары',
				'inc'=>'receipts_chpok.htm'
			),
			'chpok_end'=>array(
				'title'=>'Вскрытие тары',
				'inc'=>'receipts_chpok_end.htm'
			),
			'chpok_egais_error'=>array(
				'title'=>'Ошибка проверки алкогольной продукции',
				'inc'=>'receipts_chpok_egais_error.htm'
			),
			'modifiers'=>array(
				'title'=>'Модификаторы',
				'inc'=>'receipts_modifiers.htm'
			)
		);
		$pages[$page]['page']=$page;
		return $pages[$page];
	}

	// Выбираем чеки
	function select_receipts($query=null, $options=null) {
		if(!$query) {
			$query=array('r.id>?', 0); // чтобы хоть что-то вставить в фильтры
		}

		// формируем сортировку и лимиты
		$option='';
		if($options['order']) {
			$option.=' ORDER BY '.$options['order'];
		}
		if($options['limit']) {
			$option.=' LIMIT '.$options['limit'];
		}
		// собственно сам запрос
		$receipts=array();
		$sql="SELECT r.*, u.name, u.short_name, g.title, t.title AS table_title, room.id AS room_id, room.title AS room_title FROM receipts AS r LEFT JOIN users AS u ON u.id=r.user_id LEFT JOIN usergroups AS g ON g.id=u.group_id LEFT JOIN tables AS t ON t.id=r.table_id LEFT JOIN rooms AS room ON room.id=t.room WHERE (".$query[0].") AND r.time>0 ".$option;
		$receipts=$this->db->exec($sql, $query[1]);
		$receiptlines=new \Models\Receiptlines($this->db, $this->f3);
		foreach ($receipts as $n => $r) {
			$receipts[$n]['receiptlines']=$receiptlines->select_lines(array('receipt_id=?', $r['id']));
			if($r['type']==$this->f3->get('receipt_sales') || $r['type']==$this->f3->get('receipt_return')) {
				if($receipts[$n]['lines_count']==null) {
					$receipts[$n]['lines_count']=$receipts[$n]['lines_count_add']=count($receipts[$n]['receiptlines']);
				}
			}
			else {
				unset($receipts[$n]['lines_count']);
			}
			$receipts[$n]['paymentmethods']=json_decode($r['payment'], true);
		}
		return $receipts;
	}

	// Узнаем окрытый чек
	function get_open_receipt($rm, $store, $open=true, $all_user=0) {
		$this->reset();
		$user_id=$this->f3->get('authorization_user.id');
		$receipt_id=$this->f3->get('COOKIE.receipt_id');
		$table_id=$this->f3->get('COOKIE.table_id');
		if(!$table_id) $table_id=0;
		if($table_id>0) {
			$t=new \Models\Tables($this->db, $this->f3);
			$table=$t->select_tables(array('id=?', $table_id), array('limit'=>1));
			$r=new \Models\Rooms($this->db, $this->f3);
			$room=$r->select_rooms(array('id=?', $table[0]['room']), array('limit'=>1));
			$table[0]['room_title']=$room[0]['title'];
		}
		$user_all='';
		if($all_user) {
			$user_all=' OR user_id>0';
		}
		$this->load(array('rm=? AND store=? AND time=0 AND (user_id=? '.$user_all.' ) AND table_id=?', array($rm, $store, $user_id, $table_id)));
		if($this->dry()) {
			if(!$open) {
				return array(
					'success'=>false,
					'txt'=>'not_found'
				);
			}
			$receipt=array(
				'rm'=>$rm,
				'store'=>$store,
				'user_id'=>$user_id,
				'table_id'=>$table_id,
				'table'=>$table[0],
				'time'=>0
			);
			$this->copyFrom($receipt);
			if($this->insert()) {
				$receipt['id']=$this->get('_id');
				return array(
					'success'=>true,
					'txt'=>'save_successful',
					'receipt'=>$receipt,
					'open'=>array()
				);
			}
			else {
				return array(
					'success'=>false,
					'txt'=>'db_error'
				);
			}
		}
		else {
			$receipt=array();
			$open=array();
			do {
				$ticket=$this->cast();
				if($ticket['id']==$receipt_id) {
					$receipt=$ticket;
				}
				else {
					$open[]=$ticket;
				}
			}
			while($this->skip());
			if(empty($receipt)) {
				$receipt=$open[0];
			}
			if($receipt['partner_id']>0) {
				$p=new \Models\Partners($this->db, $this->f3);
				$partner=$p->select_partner(array('partner_id=?', $receipt['partner_id']), array('limit'=>1));
				$receipt['partner']=$partner[0];
			}
			elseif($receipt['partner_id']<0) {
				$receipt['partner']=array(
					'name'=>'Новый клиент',
					'card'=>$receipt['card'],
					'phone'=>$receipt['client']
				);
			}
			$receipt['table']=$table[0];
			return array(
				'success'=>true,
				'receipt'=>$receipt,
				'open'=>$open
			);
		}
	}

	// Ищем чеки
	function search($id, $changes, $barcode, $dates, $type, $start=0, $limit=30) {
		$where='r.type!=? AND r.rm=?';
		$val=array($this->f3->get('receipt_walk'), $this->f3->get('api_data.rm_id'));
		if($id) {
			$where.=' AND r.id=?';
			$val[]=$id;
		}
		if($changes) {
			$where='r.changes=?';
			$val[]=$changes;
		}
		if($dates) {
			if($where!='')$where.=' AND ';
			$where.='r.time>=? AND r.time<=?';
			$val[]=$dates[0];
			$val[]=$dates[1]+3600*24;
		}
		if($type) {
			if($where!='')$where.=' AND ';
			$where.='r.type=?';
			$val[]=$type;
		}
		if($barcode) {
			if($where!='') $where.=' AND ';
			$p=new \Models\Products($this->db, $this->f3);
			$products=$p->search($barcode, null, null, true);
			if($products['success']) {
				$product_id=$products['products'][0]['id'];
				$receiptlines=new \Models\Receiptlines($this->db, $this->f3);
				$lines=$receiptlines->select_lines(array('product_id=?', $product_id));
				if($lines) {
					$bwhere='';
					foreach ($lines as $l) {
						if($bwhere!='')$bwhere.=' OR ';
						$bwhere.=' r.id=? ';
						$val[]=$l['receipt_id'];
					}
					if($bwhere!='') {
						$where.=' ('.$bwhere.') ';
					}
				}
				else {
					$where.='r.id=?';
					$val[]=-1;
				}
			}
			else {
				$where.='r.id=?';
				$val[]=-1;
			}
		}
		if(!$where) {
			$where='r.id>?';
			$val[]=0;
		}
		$receipts=$this->select_receipts(array($where, $val), array('order'=>'time DESC', 'limit'=>$start.', '.$limit));
		$sql="SELECT COUNT(*) AS count FROM receipts AS r WHERE ".$where;
		$res=$this->db->exec($sql, $val);
		$count=$res[0]['count'];

		return array(
			'success'=>true,
			'count'=>$count,
			'receipts'=>$receipts
		);
	}

	// Проверка правильности заполнения контактных данных покупателя
	function client_validate($client) {
		$client=str_replace(' ', '', $client);
		$client=str_replace('(', '', $client);
		$client=str_replace(')', '', $client);

		$first=mb_substr($client, 0, 1);
		$cl=str_replace('-', '', $client);
		if($first=='+' || is_numeric($cl)) {
			// Значит это номер телефона
			if($first=='8') {
				$client='+7'.mb_substr($cl, 1);
			}
			elseif($first=='9') {
				$client='+7'.$cl;
			}
			else {
				$client=$cl;
			}
			if(mb_strlen($client)!=12) {
				return array(
					'success'=>false,
					'txt'=>'incorrect_email_or_phone'
				);
			}
		}
		else {
			// проверяем e-mail
			if(!filter_var($client, FILTER_VALIDATE_EMAIL)) {
				return array(
					'success'=>false,
					'txt'=>'incorrect_email_or_phone'
				);
			}
		}
		return array(
			'success'=>true,
			'client'=>$client
		);
	}

	// Пробиваем чек
	function add_ticket($receipt_id, $change, $type, $paymentmethod, $client_sum, $sum, $lines, $client, $discount=0, $partner_id=0, $sales_receipts=0, $print=1, $partner_bonus=0, $partner_bonus_sum=0, $bonus_pay=0, $executor=0) {
		if($client) {
			$client_validate=$this->client_validate($client);
			if(!$client_validate['success']) {
				return $client_validate;
			}
			else {
				$client=$client_validate['client'];
			}
		}
		if(is_array($lines)) {
			$lines_count=count($lines);
		}
		else {
			$lines_count=0;
		}
		if($lines_count==0) {
			return array(
				'success'=>false,
				'txt'=>'lines_not_found'
			);
		}

		// Формируем данные оплаты
		$payment=array();
		foreach ($paymentmethod as $p_id) {
			$payment[]=array('method'=>$p_id, 'sum'=>$client_sum[$p_id]);
		}

		// формируем данные чека
		$receipt=array(
			'id'=>$receipt_id,
			'changes'=>$change['id'],
			'changes_data'=>json_encode($change),
			'time'=>microtime(true),
			'type'=>$type,
			'payment'=>json_encode($payment),
			'sum'=>$sum,
			'client'=>$client,
			'partner_id'=>$partner_id,
			'lines_count'=>$lines_count,
		);
		if($executor) {
			$receipt['executor']=$executor;
		}
		$nofr=$this->f3->get('POST.nofr');
		if($nofr) {
			$receipt['nofr']=$nofr;
		}
		
		$this->reset();
		$this->load(array('id=?', $receipt_id), array('limit'=>1));
		if($this->dry()) {
			return array(
				'success'=>false,
				'txt'=>'not_found'
			);
		}
		$this->copyFrom($receipt);
		// Проверяем наличие алкоголя в чеке
		$egais=array();
		if(array_sum(array_column($lines, 'egais'))>0) {
			if($type==2) $return=true;
			else $return=false;
			$egais=$this->egais->cheque($change['id'], $receipt_id, $lines, $return);
		}
		$ticket=$this->cast();
		if($ticket['table_id']) {
			$t=new \Models\Tables($this->db, $this->f3);
			$table=$t->select_tables(array('id=?', $ticket['table_id']), array('limit'=>1));
			$r=new \Models\Rooms($this->db, $this->f3);
			$room=$r->select_rooms(array('id=?', $table[0]['room']), array('limit'=>1));
			$table[0]['room_title']=$room[0]['title'];
			$ticket['table']=$table[0];
		}
		$receipt['receipt']=$ticket;
		$this->fr->ticket($receipt, $lines, $discount, $sales_receipts, $print, $egais, $partner_bonus, $partner_bonus_sum, $bonus_pay);
		if(!$this->update()) {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}


		return array(
			'success'=>true,
			'txt'=>'save_successful'
		);
	}

	function ticket_chpok($rm, $store, $change) {
		// формируем данные чека
		$receipt=array(
			'user_id'=>$this->f3->get('authorization_user.id'),
			'rm'=>$rm,
			'store'=>$store,
			'changes'=>$change['id'],
			'changes_data'=>json_encode($change),
			'time'=>0,
			'type'=>1,
			'payment'=>json_encode(array()),
			'sum'=>0,
			'client'=>'',
			'partner_id'=>0,
			'lines_count'=>1
		);
		$nofr=$this->f3->get('POST.nofr');
		if($nofr) {
			$receipt['nofr']=$nofr;
		}
		$this->reset();
		$this->copyFrom($receipt);
		if(!$this->insert()) {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
		$receipt['id']=$this->get('_id');

		return array(
			'success'=>true,
			'txt'=>'save_successful',
			'id'=>$receipt['id'],
			'receipt'=>$receipt
		);
	}

	function ticket_return($rm, $store, $change, $post) {
		if(is_array($post['receiptlines'])) $lines_count=count($post['receiptlines']);
		else $lines_count=0;
		if($lines_count==0) {
			return array(
				'success'=>false,
				'txt'=>'lines_not_found'
			);
		}

		// Формируем данные оплаты
		$payment=array();
		foreach ($post['paymentmethod'] as $p_id) {
			$payment[]=array('method'=>$p_id, 'sum'=>$post['client_sum'][$p_id]);
		}

		// формируем данные чека
		$receipt=array(
			'user_id'=>$this->f3->get('authorization_user.id'),
			'rm'=>$rm,
			'store'=>$store,
			'changes'=>$change['id'],
			'changes_data'=>json_encode($change),
			'time'=>0,
			'type'=>$post['type'],
			'payment'=>json_encode($payment),
			'sum'=>$post['sum'],
			'client'=>'',
			'partner_id'=>$post['partner_id'],
			'lines_count'=>$lines_count
		);
		$nofr=$this->f3->get('hold');
		if($nofr) {
			$receipt['nofr']=$nofr;
		}
		$this->reset();
		$this->copyFrom($receipt);
		if(!$this->insert()) {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
		$receipt['id']=$this->get('_id');

		return array(
			'success'=>true,
			'txt'=>'save_successful',
			'id'=>$receipt['id'],
			'receipt'=>$receipt
		);
	}

	// Проводим чек возврата
	function ticket_ready($receipt, $post) {
		$this->reset();
		$this->load(array('id=?', $receipt['id']), array('limit'=>1));
		if($this->dry()) {
			return array(
				'success'=>false,
				'txt'=>'not_found'
			);
		}
		$this->time=microtime(true);
		$egais=array();
		if(array_sum(array_column($post['receiptlines'], 'egais'))>0) {
			$egais=$this->egais->cheque($receipt['changes'], $receipt['id'], $post['receiptlines'], true);
		}
		if($this->table_id) {
			$t=new \Models\Tables($this->db, $this->f3);
			$table=$t->select_tables(array('id=?', $this->table_id), array('limit'=>1));
			$r=new \Models\Rooms($this->db, $this->f3);
			$room=$r->select_rooms(array('id=?', $table[0]['room']), array('limit'=>1));
			$table[0]['room_title']=$room[0]['title'];
			$receipt['table']=$table[0];
		}
		$receipt['receipt']=$receipt;
		$this->fr->ticket($receipt, $post['receiptlines'], $post['discount'], 0, 1, $egais);
		if($this->update()) {
			return array(
				'success'=>true,
				'txt'=>'save_successful',
				'function'=>'return_reset()'
			);
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
	}

	// Проводим вскрытие бутылки
	function ticket_chpok_ready($receipt, $product) {
		$this->reset();
		$this->load(array('id=?', $receipt['id']), array('limit'=>1));
		if($this->dry()) {
			return array(
				'success'=>false,
				'txt'=>'not_found'
			);
		}
		$this->time=microtime(true);

		if($product[0]['egais']>0) {
			$this->egais->cheque($receipt['changes'], $receipt['id'], $product, false);
		}

		if($this->update()) {
			return array(
				'success'=>true,
				'txt'=>'save_successful',
				'close_all_window'=>true
			);
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
	}

	// Чек смены
	function ticket_change($api_data, $change, $type, $paymentmethod, $sum=0) {
		$this->reset();
		// Формируем данные оплаты
		$payment[]=array('method'=>$paymentmethod, 'sum'=>$sum);
		// формируем данные чека
		$receipt=array(
			'store'=>$api_data['store_id'],
			'rm'=>$api_data['rm_id'],
			'user_id'=>$this->f3->get('authorization_user.id'),
			'changes'=>$change['id'],
			'changes_data'=>json_encode($change),
			'time'=>microtime(true),
			'type'=>$type,
			'payment'=>json_encode($payment),
			'sum'=>$sum,
			'client'=>'',
			'partner_id'=>0
		);
		$this->copyFrom($receipt);
		if($this->insert()) { // сохраняем
			return array(
				'success'=>true,
				'txt'=>'save_successful',
				'id'=>$this->get('_id')
			);
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
	}

	// Удаление чека
	function delete_receipt($id) {
		$this->reset();
		$this->load(array('id=?', $id), array('limit'=>1));
		$this->erase();
		$this->db->exec("DELETE FROM receiptlines WHERE receipt_id=?", $id);
	}

	// Внесение и изъятие денег из кассы
	function cashin($api_data, $change, $pay, $sum, $type, $create_receipt=0, $description='', $print_type=null) {
		$this->fr->cashin($change['id'], $sum, $print_type);
		$receipt=array(
			'store'=>$api_data['store_id'],
			'rm'=>$api_data['rm_id'],
			'user_id'=>$this->f3->get('authorization_user.id'),
			'changes'=>$change['id'],
			'changes_data'=>json_encode($change),
			'time'=>microtime(true),
			'type'=>$type,
			'payment'=>json_encode(array(array('method'=>$pay, 'sum'=>$sum))),
			'sum'=>$sum,
			'client'=>'',
			'create_receipt'=>$create_receipt,
			'description'=>$description
		);
		$nofr=$this->f3->get('hold');
		if($nofr) {
			$receipt['nofr']=$nofr;
		}
		$this->reset();
		$this->copyFrom($receipt);
		$this->save();
		if($this->get('_id')) {
			return array(
				'success'=>true,
				'txt'=>'save_successful',
				'form_reset'=>true
			);
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
	}

	// Статистика по смене
	function change_statistic($change) {
		$receipts=$this->select_receipts(array('r.changes=? AND r.type!=? AND r.type!=?', array($change, $this->f3->get('receipt_change_open'), $this->f3->get('receipt_change_close'))));
		$report=array(
			$this->f3->get('receipt_sales')=>array('sum'=>0, 'count'=>0),
			$this->f3->get('receipt_return')=>array('sum'=>0, 'count'=>0),
			$this->f3->get('receipt_cashin')=>array('sum'=>0, 'count'=>0),
			$this->f3->get('receipt_cashout')=>array('sum'=>0, 'count'=>0),
			'receipt_remote'=>array('sum'=>0, 'count'=>0),
		);
		foreach ($receipts as $r) {
			$report[$r['type']]['count']+=1;
			$report[$r['type']]['sum']+=$r['sum'];
			$pays=json_decode($r['payment'], true);
			foreach ($pays as $p) {
				if(!$p['sum'])$p['sum']=0;
				if($p['sum']>$r['sum']) {
					$p['sum']=$r['sum'];
				}
				$report[$r['type']]['pay'][$p['method']]+=$p['sum'];
				if($r['remote']>0) {
					$report['receipt_remote']['pay'][$p['method']]+=$p['sum'];
					$report['receipt_remote']['count']+=1;
					$report['receipt_remote']['sum']+=$r['sum'];
				}
			}
		}
		return $report;
	}

	// Отчет по секциям
	function rep_sections() {
		$fr_type=$this->fr->get_fr()['type'];
		if($fr_type==1) {
			$this->fr->rep_sections();
			return array(
				'success'=>true,
				'txt'=>'report_is_ready'
			);
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'fr_only'
			);
		}
	}

	// Печать копии последнего чека
	function print_last() {
		if($this->fr->sets['active']) {
			$this->fr->c();
			return array(
				'success'=>true,
				'txt'=>'request_has_been_sent'
			);
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'kkm_is_not_activity'
			);
		}
	}

	// Открытие нового пустого чека
	function open_new($rm, $store) {
		$user_id=$this->f3->get('authorization_user.id');
		$table_id=$this->f3->get('COOKIE.table_id');
		if(!is_numeric($table_id)) $table_id=0;
		$this->reset();
		$receipt=array(
			'rm'=>$rm,
			'store'=>$store,
			'user_id'=>$user_id,
			'table_id'=>$table_id,
			'time'=>0
		);
		$this->copyFrom($receipt);
		if($this->insert()) {
			$this->f3->set('COOKIE.receipt_id', $this->get('_id'));
			return array(
				'success'=>true,
				'txt'=>'save_successful',
				'reload'=>array('.receiptlines', '#receipts_buttons'),
				'reload_menu'=>true,
				'close_all_window'=>true
			);
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
	}

	// Переключение на другой чек
	function switch_receipt($id) {
		if(!$id) {
			return array(
				'success'=>false,
				'txt'=>'not_enough_data'
			);
		}
		$this->reset();
		$this->load(array('id=?', $id), array('limit'=>1));
		if($this->dry()) {
			return array(
				'success'=>false,
				'txt'=>'not_found'
			);
		}

		$this->f3->set('COOKIE.receipt_id', $this->id);
		$this->f3->set('COOKIE.table_id', $this->table_id);
		return array(
			'success'=>true,
			'txt'=>'save_successful',
			'reload'=>array('.receiptlines', '#receipts_buttons', '.button_total'),
			'reload_menu'=>true,
			'close_all_window'=>true
		);
	}

	// Добавление клиента к чеку
	function add_partner($receipt_id, $partner) {
		$this->reset();
		$this->load(array('id=? AND time=0', $receipt_id), array('limit'=>1));
		if($this->dry()) {
			return array(
				'success'=>false,
				'txt'=>'not_found'
			);
		}
		$this->partner_id=$partner['partner_id'];
		if($partner['email']) {
			$contact=$partner['email'];
		}
		else {
			$contact=$partner['phone'];
		}
		$this->client=$contact;
		$this->discount=$partner['discount'];
		$this->card=$partner['card'];
		if($this->update()!==false) {
			return array(
				'success'=>true,
				'txt'=>'save_successful',
				'reload'=>array('.receiptlines', '#receipts_buttons'),
				'close_all_window'=>true
			);
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
	}

	// Убрать клиента из чека
	function remove_partner($id) {
		$this->reset();
		$this->load(array('id=?', $id), array('limit'=>1));
		if($this->dry()) {
			return array(
				'success'=>false,
				'txt'=>'not_found'
			);
		}
		$this->partner_id='';
		$this->discount=0;
		$this->card='';
		$this->client='';
		if($this->update()) {
			return array(
				'success'=>true,
				'txt'=>'save_successful',
				'reload'=>array('.receiptlines', '#receipts_buttons'),
				'close_all_window'=>true
			);
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
	}

	// Сохранение произвольной скидки в чек
	function set_discount($discount) {
		if($discount=='.') $discount=0;
		if(is_numeric($discount) && $discount>=0 && $discount<=100) {
			$user=$this->f3->get('authorization_user');
			if(!in_array('receipts/discount', $user['module']) && $discount>0) {
				// Значит нельзя устанавливать произвольную скидку
				// Проверяем можно ли указать такую скидку
				$loyalty_models=new \Models\Loyalty($this->db, $this->f3);
				if(!$loyalty_models->select_discounts($discount)) {
					return array(
						'success'=>false,
						'txt'=>'incorrect_select_discount'
					);
				}
			}
			$this->reset();
			$id=$this->f3->get('COOKIE.receipt_id');
			$this->load(array('id=?', $id), array('limit'=>1));
			if($this->dry()) {
				return array(
					'success'=>false,
					'txt'=>'not_found'
				);
			}
			$this->discount=$discount;
			if($this->update()!==false) {
				return array(
					'success'=>true,
					'txt'=>'save_successful',
					'reload'=>array('.receiptlines')
				);
			}
			else {
				return array(
					'success'=>false,
					'txt'=>'db_error'
				);
			}
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'incorrect_discount'
			);
		}
	}

	// Поиск всех открытых чеков
	function all_open() {
		$sql="SELECT r.*, u.name, u.short_name, g.title, SUM(l.count) AS lines_count, SUM(CASE l.vat_type WHEN 0 THEN l.price*l.count WHEN 1 THEN (l.price+(l.price/100*l.vat))*l.count END) AS lines_sum, CASE WHEN l.receipt_id>0 THEN l.receipt_id ELSE r.id END AS r_id, rooms.title AS room_title, rooms.id AS room_id, t.title AS table_title FROM receipts AS r LEFT JOIN users AS u ON u.id=r.user_id LEFT JOIN usergroups AS g ON g.id=u.group_id LEFT JOIN receiptlines AS l ON receipt_id=r.id LEFT JOIN tables AS t ON t.id=r.table_id LEFT JOIN rooms ON rooms.id=t.room WHERE r.time=0 GROUP BY r_id";
		$receipts=$this->db->exec($sql);
		$res=$this->db->exec($sql);
		return array(
			'success'=>true,
			'receipts'=>$receipts
		);
	}

	// Поиск всех открытых чеков на других кассах
	function other_all_open($data, $receipts) {
		if(!$data) {
			return $receipts;
		}
		foreach ($data as $ip=>$request) {
			$json=json_decode($request, true);
			if($json['success']) {
				foreach ($json['receipts'] as $receipt) {
					$receipt['ip']=$ip;
					$receipts[]=$receipt;
				}
			}
		}
		return $receipts;
	}

	// Перехват чека
	function intercept($rm, $store, $id) {
		$this->reset();
		$this->load(array('id=? AND time=0', $id), array('limit'=>1));
		if($this->dry()) {
			return array(
				'success'=>false,
				'txt'=>'not_found'
			);
		}
		$this->rm=$rm;
		$this->store=$store;

		$this->user_id=$this->f3->get('authorization_user.id');
		$sets=$this->f3->get('base_settings');
		if($sets['cafe_mode']==1) {
			if($this->table_id==0) $this->table_id=$this->f3->get('COOKIE.table_id');
		}
		else {
			$this->table_id=0;
		}
		if($this->update()!==false) {
			return array(
				'success'=>true,
				'txt'=>'save_successful',
				'reload'=>array('.receiptlines', '#receipts_buttons'),
				'reload_menu'=>true,
				'receipt'=>$this->cast(),
				'close_all_window'=>true
			);
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
	}

	// Удаление чека с другой кассы
	function other_delete_receipt($ip, $id) {
		$web=\Web::instance();
		$options = array(
			'method' => 'GET',
    		'follow_location' => 1
		);
		$query='http://'.$ip.'/multikassa/delete_receipt?id='.$id;
		$request=$web->request($query, $options);
		return $json=json_decode($request['body'], true);
	}

	// Перехват чека с другой кассы
	function other_intercept($rm, $store, $ip, $id) {
		$web=\Web::instance();
		$options = array(
			'method' => 'GET',
    		'follow_location' => 1
		);
		$query='http://'.$ip.'/multikassa/intercept?id='.$id;
		$request=$web->request($query, $options);
		$json=json_decode($request['body'], true);
		if(!$json['success']) {
			return $json;
		}
		$receipt=$json['receipt'];
		$receipt['rm']=$rm;
		$lines=$json['receiptlines'];
		unset($receipt['id']);
		$user_id=$this->f3->get('authorization_user.id');
		$receipt['user_id']=$user_id;
		$table_id=$this->f3->get('COOKIE.table_id');
		if(!$receipt['table_id'] && $table_id) {
			$receipt['table_id']=$table_id;
		}
		$this->reset();
		$this->copyFrom($receipt);
		if($this->insert()===false) {
			return array(
				'success'=>false,
				'db_error'
			);
		}
		$receipt['id']=$this->get('_id');
		if($lines) {
			$l=new \Models\Receiptlines($this->db, $this->f3);
			foreach ($lines as $line) {
				$l->reset();
				unset($line['id']);
				$line['receipt_id']=$receipt['id'];
				$l->copyFrom($line);
				$l->insert();
			}
		}
		return array(
			'success'=>true,
			'txt'=>'save_successful',
			'reload'=>array('.receiptlines', '#receipts_buttons'),
			'reload_menu'=>true,
			'receipt'=>$receipt,
			'close_all_window'=>true,

		);
	}

	// Получаем открытый пустой чек
	function get_empty($rm, $store) {
		$sql="SELECT r.id, COUNT(l.id) AS count FROM `receipts` AS `r` LEFT JOIN `receiptlines` AS `l` ON l.receipt_id=r.id WHERE r.time=0 AND r.rm=? AND r.store=? GROUP BY (r.id) ORDER BY r.id";
		$val=array($rm, $store);
		$res=$this->db->exec($sql, $val);
		if($res) {
			foreach ($res as $r) {
				if($r['count']==0) {
					return $r['id'];
				}
			}
		}
		return false;
	}

	// Получаем открытые не пустые чеки
	function get_not_empty($rm, $store) {
		$sql="SELECT COUNT(r.id) AS count FROM `receipts` AS `r` JOIN `receiptlines` AS `l` ON l.receipt_id=r.id WHERE r.time=0 AND r.rm=? AND r.store=? GROUP BY (l.receipt_id)";
		$val=array($rm, $store);
		$res=$this->db->exec($sql, $val);
		return $res[0]['count'];
	}
	
	// Получаем открытые не пустые чеки для стола
	function get_not_empty_for_table($table_id) {
		$sql="SELECT r.*, SUM(l.count) AS lines_count, CASE WHEN l.receipt_id>0 THEN l.receipt_id ELSE r.id END AS r_id FROM receipts AS r JOIN receiptlines AS l ON receipt_id=r.id WHERE r.time=0 AND r.table_id=? GROUP BY r_id";
		$val=array($table_id);
		$res=$this->db->exec($sql, $val);
		return $res;
	}

	// Удаляем открытые чеки
	function delete_open($rm, $store) {
		// Список открытых чеков
		$receipts=$this->db->exec("SELECT `id` FROM `receipts` WHERE `time`=0 AND `rm`=? AND `store`=?", array($rm, $store));
		if(!empty($receipts)) {
			$in='';
			$val=array();
			foreach ($receipts as $r) {
				if(!empty($val)) {
					$in.=',';
				}
				$in.='?';
				$val[]=$r['id'];
			}
			$sql="DELETE FROM `receipts` WHERE `id` IN (".$in.")";
			$res=$this->db->exec($sql, $val);
			if($res===false) {
				return array(
					'success'=>false,
					'txt'=>'db_error'
				);
			}
			$sql="DELETE FROM `receiptlines` WHERE `receipt_id` IN (".$in.")";
			$res=$this->db->exec($sql, $val);
			if($res===false) {
				return array(
					'success'=>false,
					'txt'=>'db_error'
				);
			}
		}

		return array(
			'success'=>true
		);
	}

	// Перемещение чека на другой стол
	function move_receipt($receipt_id, $table_id) {
		if(!$receipt_id || !$table_id) {
			return array(
				'success'=>false,
				'txt'=>'not_enough_data'
			);
		}
		$this->reset();
		$this->load(array('id=?', $receipt_id), array('limit'=>1));
		if($this->dry()) {
			return array(
				'success'=>false,
				'txt'=>'not_found'
			);
		}
		$t=new \Models\Tables($this->db, $this->f3);
		$t->load(array('id=?', $table_id), array('limit'=>1));
		if($t->dry()) {
			return array(
				'success'=>false,
				'txt'=>'not_found'
			);
		}

		$this->table_id=$table_id;
		if($this->update()) {
			return array(
				'success'=>false,
				'txt'=>'save_successful',
				'function'=>'$("#screen").load("?table_id='.$table_id.' #screen_window", function(){receiptlines_div_resize();});',
				'close_all_window'=>true
			);
		}
		else {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
	}

	// Добавляем интернет-заказ к чеку
	function push_order($receipt_id, $order) {
		$this->reset();
		$this->load(array('id=?', $receipt_id), array('limit'=>1));
		if($this->dry()) {
			return array(
				'success'=>false,
				'txt'=>'not_found'
			);
		}
		$this->partner_id=$order['partner_id'];
		$client=$order['partner_email'];
		if(!$client) {
			$client=$order['partner_phone'];
		}
		$this->client=$client;
		$this->discount=$order['partner_discount'];
		if($order['remote']) {
			$this->remote=$order['remote'];
		}
		if($this->update()===false) {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
		if($order['partner_id']) {
			$partner_data=array(
				'card'=>$order['partner_card'],
				'partner_id'=>$order['partner_id'],
				'name'=>$order['partner_title'],
				'email'=>$order['partner_email'],
				'phone'=>$order['partner_phone'],
				'discount'=>$order['partner_discount'],
			);
			$partners=new \Models\Partners($this->db, $this->f3);
			$partner=$partners->save_partner($partner_data);
		}

		if($order['receiptlines']) {
			$lines=new \Models\Receiptlines($this->db, $this->f3);
			foreach ($order['receiptlines'] as $l) {
				$l['id']=$l['product_id'];
				$l['line_discount']=$l['discount'];
				$l['discount']=0;
				$l['price0']=$l['price'];
				if($l['line_discount']!=0) {
					$l['price']=$l['price']-($l['price']*($l['line_discount']/100));
					$l['description']='Установлена скидка';
					$l['loyalty']=2;
				}
				$lines->add_line($receipt_id, $l, $l['count']);
			}
		}

		return array(
			'success'=>true,
			'txt'=>'save_successful',
			'reload'=>array('.receiptlines', '#receipts_buttons', '.button_total'),
			'reload_menu'=>true,
			'close_all_window'=>true
		);

	}

	// Печать пречека или товарного чека
	function print($id) {
		$this->reset();
		$this->load(array('id=?', max($id, -1)), array('limit'=>1));
		if($this->dry()) {
			return array(
				'success'=>false,
				'txt'=>'not_found'
			);
		}

		$receipt=$this->cast();
		if($receipt['table_id']) {
			$t=new \Models\Tables($this->db, $this->f3);
			$table=$t->select_tables(array('id=?', $receipt['table_id']), array('limit'=>1));
			$r=new \Models\Rooms($this->db, $this->f3);
			$room=$r->select_rooms(array('id=?', $table[0]['room']), array('limit'=>1));
			$table[0]['room_title']=$room[0]['title'];
			$receipt['table']=$table[0];
		}
		$receipt['receiptlines']=array();
		$receiptlines=new \Models\Receiptlines($this->db, $this->f3);
		$lines=$receiptlines->select_lines(array('receipt_id=?', $receipt['id']));
		foreach ($lines as $line) {
			if($line[$this->printer]==1) {
				continue;
			}
			if(($this->printer=='kitchen' || $this->printer=='bar') && $line['print_group']!=$this->printer) {
				continue;
			}
			$receipt['receiptlines'][]=$line;
		}
		if($receipt['time']>0) {
			$pays=json_decode($receipt['payment'], true);
			$p=new \Models\Paymentmethods($this->db, $this->f3);
			$paymentmethods=$p->select_method();
			foreach ($paymentmethods as $p) {
				$methods[$p['id']]=$p['title'];
			}
			foreach ($pays as $n => $p) {
				$pays[$n]['title']=$methods[$p['method']];
			}
			$receipt['pays']=$pays;
			$u=new \Models\Users($this->db, $this->f3);
			$user=$u->select_users(array('u.id=?', $receipt['user_id']), array('limit'=>1));
			$receipt['user']=$user[0];
		}
		if($receipt['receiptlines']) {
			if($this->fr->sets['line_by_line']==1) {
				$for_print=array();
				foreach ($receipt['receiptlines'] as $line) {
					if($line['parent_id']==0 && !empty($for_print)){
						$this->fr->print($for_print);
					}
					if($line['parent_id']==0) {
						$for_print=$receipt;
						$for_print['receiptlines']=array($line);
					}
					else {
						$for_print['receiptlines'][]=$line;
					}
				}
				if(!empty($for_print)) {
					$this->fr->print($for_print);
				}
			}
			else {
				$this->fr->print($receipt);
			}
			if($this->printer=='kitchen' || $this->printer=='bar') {
				foreach ($receipt['receiptlines'] as $line) {
					$receiptlines->print_ok($line['id'], $this->printer);
				}
			}
		}
		return array(
			'success'=>true
		);
	}

	// Документы отправленные для удаленной фискализации и успешно фискализированные
	function success_fiscalization($time) {
		$receipts=array();
		$this->reset();
		$this->load(array('remote>0 AND time>=?', $time));
		if(!$this->dry()){
			do {
				$receipts[]=$this->remote;
			}
			while ($this->skip());
		}
		return $receipts;
	}

	// Проверка введенного штрих-кода сотрудника
	function validate_walk($data) {
		$s=new \Models\Settings($this->f3, $this->db);
		$sets=$s->get_settings(array('worker_code_pr'));
		if(!$sets['worker_code_pr']) {
			return array(
				'success'=>false,
				'txt'=>'workers_code_is_not_specified'
			);
		}
		$barcode=trim($data['barcode']);
		if(mb_strlen($barcode)!=13 || mb_substr($barcode, 0, mb_strlen($sets['worker_code_pr']))!=$sets['worker_code_pr'] || !ctype_digit($barcode)) {
			return array(
				'success'=>false,
				'txt'=>'incorrect_workers_code'
			);
		}
		$data['barcode']=$barcode;
		return array(
			'success'=>true,
			'data'=>$data
		);
	}

	// Создаем документ прохода сотрудника
	function add_walk($data) {
		$receipt=array(
			'store'=>$data['store'],
			'rm'=>$data['rm'],
			'user_id'=>0,
			'changes'=>0,
			'changes_data'=>'',
			'time'=>microtime(true),
			'type'=>$data['type'],
			'payment'=>'',
			'sum'=>0,
			'client'=>$data['barcode'],
			'create_receipt'=>0,
			'description'=>$data['action']
		);
		$this->reset();
		$this->copyFrom($receipt);
		if($this->save()===false) {
			return array(
				'success'=>false,
				'txt'=>'db_error'
			);
		}
		return array(
			'success'=>true,
			'txt'=>'save_successful',
			'close_all_window'=>true
		);
	}

	// Находим МРЦ - максимальная розничная цена
	function mrc($mrc) {
		$result=0;
		$s=array(
			'A'=>0,'B'=>1,'C'=>2,'D'=>3,'E'=>4,'F'=>5,'G'=>6,'H'=>7,'I'=>8,'J'=>9,'K'=>10,
			'L'=>11,'M'=>12,'N'=>13,'O'=>14,'P'=>15,'Q'=>16,'R'=>17,'S'=>18,'T'=>19,'U'=>20,
			'V'=>21,'W'=>22,'X'=>23,'Y'=>24,'Z'=>25,'a'=>26,'b'=>27,'c'=>28,'d'=>29,'e'=>30,
			'f'=>31,'g'=>32,'h'=>33,'i'=>34,'j'=>35,'k'=>36,'l'=>37,'m'=>38,'n'=>39,'o'=>40,
			'p'=>41,'q'=>42,'r'=>43,'s'=>44,'t'=>45,'u'=>46,'v'=>47,'w'=>48,'x'=>49,'y'=>50,
			'z'=>51,'0'=>52,'1'=>53,'2'=>54,'3'=>55,'4'=>56,'5'=>57,'6'=>58,'7'=>59,'8'=>60,
			'9'=>61,'!'=>62,'"'=>63,'%'=>64,'&'=>65,'\''=>66,'*'=>67,'+'=>68,'-'=>69,'.'=>70,
			'/'=>71,'_'=>72,','=>73,':'=>74,';'=>75,'='=>76,'<'=>77,'>'=>78,'?'=>79
		);
		for($i=0; $i<4; $i++) {
			$a=mb_substr($mrc, $i, 1);
			if($s[$a]) {
				$n[$i]=$s[$a];
			}
			else {
				$n[$i]=0;
			}
		}
		$result=$n[1]*80;
		$result=($result+$n[2])*80;
		$result+=$n[0]+$n[3];
		return $result/100;
	}

	// Обработка кода маркировки для проверки в честном знаке
	function mark_for_chz($mark) {
		$len=mb_strlen($mark);
		$mrc=false;
		if($len==29) { // Табак
			// первые 14 символов - GTIN-14, 0 + ean-13
			// следующие 7 символов - Серийный номер
			// следующие 4 символа - максимальная розничня цена
			// последние 4 символа - крипто-хвост
			$mrc=mb_substr($mark, 21, 4);
			$mrc=$this->mrc($mrc);
			$mark=mb_substr($mark, 0, 21);
		}
		elseif($len!=8
            && $len!=13
            && $len!=14
            && preg_match("/[A-Za-z0-9\/\\!”%&’()*+-.,:;=<>?]/", $mark)
            && mb_substr($mark, 0, 2)=='01'
            && mb_substr($mark, 16, 2)=='21') { //Лекарства
				$lp=true;
				$gtin=mb_substr($mark, 2, 14);
				$serial=mb_substr($mark, 18, 13);
				if(mb_strpos($mark, '8005')>=31) {
					//$mrc=mb_substr($mark, 31, 6);
				}
				$mark=$gtin.$serial;
		}
		return array(
			'code'=>$mark,
			'mrc'=>$mrc
		);
	}

	// Проверка статуса маркированного товара
	function check_mark_status($status) {
		if($status=='INTRODUCED') {
			return array(
				'success'=>true
			);
		}
		return array(
			'success'=>false,
			'txt'=>'labeling_code_not_entered_into_circulation'
		);
	}

	// Проверяем правильность составления дата матрикс
	function control_fnc($mark) {
		$len=mb_strlen($mark);
		if($len!=8
            && $len!=13
            && $len!=14
            && preg_match("/[A-Za-z0-9\/\\!”%&’()*+-.,:;=<>?]/", $mark)
            && mb_substr($mark, 0, 2)=='01'
            && mb_substr($mark, 16, 2)=='21') { // Значит дата маткрис
			if(mb_strpos($mark, '')===false && mb_strpos($mark, '\\u001d')===false) {
				$mark=''.mb_substr($mark, 0, 31).''.mb_substr($mark, 31, 6).''.mb_substr($mark, 37);
			}
		}
		return $mark;
	}

	// Девайсы
	function get_device() {
		$user_agents=array(
			'Platform: Android 5.0 (API 21)',
			'Platform: Android 5.0.1 (API 21)',
			'Platform: Android 5.0.2 (API 21)',
			'Platform: Android 5.1 (API 22)',
			'Platform: Android 5.1.1 (API 22)',
			'Platform: Android 6.0 (API 23)',
			'Platform: Android 6.0.1 (API 23)',
			'Platform: Android 7.0 (API 24)',
			'Platform: Android 7.1 (API 25)',
			'Platform: Android 7.1.1 (API 25)',
			'Platform: Android 7.1.2 (API 25)',
			'Platform: Android 8.0 (API 26)',
			'Platform: Android 8.1 (API 27)',
			'Platform: Android 9.0 (API 28)',
			'Platform: Android 10.0 (API 29)'
		);
		$devices=array(
			'samsung SM-J120F',
			'samsung SM-N930F',
			'samsung SM-N770F',
			'redmi M1908C3IG',
			'redmi M1901F7G',
			'redmi M1810F6LG',
			'huawei EVA-L09',
			'huawei AGS-l09',
			'huawei BG2-U01',
			'asus ZE554KL',
			'asus ZC554KL',
			'asus D541N'
		);
		return array(
			'user-agent'=>$user_agents[rand(0, count($user_agents)-1)],
			'device'=>$devices[rand(0, count($devices)-1)]
		);
	}

	function check_double_mark($mark) {
		if($this->f3->get('COOKIE.receipt_id')) {
			$receiptlines=new \Models\Receiptlines($this->db, $this->f3);
			$lines=$receiptlines->select_lines(array('mark=? AND receipt_id=?', array(json_encode(array($mark)), $this->f3->get('COOKIE.receipt_id'))));
			if($lines) {
				return array(
					'success'=>false,
					'txt'=>'marking_code_already_added',
				);
			}
		}
		return array(
			'success'=>true
		);
	}

	// Проверяем маркировку через фр (ФФД 1.2)
	function check_mark_fr($mark) {
		return $this->fr->check_mark($mark);
	}

	// Проверяем маркировку товара
	function check_mark($mark) {
		if($this->fr->sets['version']=='1.2') {
			return $this->check_mark_fr($mark);
		}
		//$mark=str_replace('%26', '&', $mark);
		$mark=str_replace(' ', '+', $mark);
		$check_double=$this->check_double_mark($mark);
		if(!$check_double['success']) {
			return $check_double;
		}
		// проверка дата матрикс
		$mark=$this->control_fnc($mark);
		$web=\Web::instance();
		$device=$this->get_device();
		$options = array(
			'method' => 'POST',
    		'follow_location' => 1,
    		'header'=>array(
    			'Content-Type: application/json; charset=UTF-8',
    			'user-agent: '.$device['user-agent'],
    			'Device: '.$device['device'],
    			'AppVersion: 4.5.3',
    			'AppVersionCode: 101'
    		),
    		'content'=>json_encode(array('code'=>$mark, 'codeType'=>'datamatrix'))
		);
		$query='https://mobile.api.crpt.ru/mobile/check';
		$request=$web->request($query, $options);
		$json=json_decode($request['body'], true);
		$status=$json['status'];
		if($status) {
			$check=$this->check_mark_status($status);
			if($check['success']) {
				return array(
					'success'=>true,
					'code'=>$mark
				);
			}
			else {
				return array(
					'success'=>false,
					'txt'=>$check['txt']
				);
			}
		}
		else {
			$error=$json['errorMessage'];
			if(!$error) {
				$error=json_decode($request['body'], true)['error_message'];
			}
			return array(
				'success'=>false,
				'txt'=>$error
			);
		}
		return array(
			'success'=>false,
			'txt'=>implode(';', $request)
		);
	}

	// Проверка товара ЕГАИС
	function check_egais($code) {
		$check_double=$this->check_double_mark($code);
		if(!$check_double['success']) {
			return $check_double;
		}

		return $this->egais->mark_check($code);
	}

	// Указываем, что оплата бонусами
	function bonus_pay($receipt) {
		if($receipt['partner']['bonus']>0 || $receipt['bonus_pay']>0) {
			if($receipt['bonus_pay']>0) {
				$bonus_pay=0;
			}
			else {
				$bonus_pay=min(floor($receipt['sum']/100*$receipt['partner']['bonus_pay']), $receipt['partner']['bonus']);
			}
			$this->reset();
			$this->load(array('id=?', $receipt['id']), array('limit'=>1));
			if($this->dry()) {
				return array(
					'success'=>false,
					'txt'=>'not_found'
				);
			}
			$this->bonus_pay=$bonus_pay;
			if($this->update()===false) {
				return array(
					'success'=>false,
					'txt'=>'db_error'
				);
			}
			return array(
				'success'=>true,
				'txt'=>'save_successful',
				'reload'=>array('.receiptlines', '#receipts_buttons'),
				'close_all_window'=>true
			);
		}
		return array(
			'success'=>false,
			'txt'=>'no_bonus_to_pay'
		);
	}
}
